%!TEX root = main.tex

Due to the page limit,
in this section,
we only cover several key features of PicoScenes Driver.

\textit{UWB Access Unlocked on QCA9300:} To support 2.4/5GHz dual-band,
Wi-Fi NIC hardware can virtually access much wider spectrum 
beyond the standard channelization.
For example, 
QCA9300's carrier frequency synthesizer ($f_c$ synthesizer) 
supports over GHz spectrum in both 2.4G/5GHz bands\cite{5746268}.
%
However, these spectrum is inaccessible 
until we take the full control of $f_c$ synthesizer.
IWL5300 adopts the \textit{full}-MAC design, 
which means its driver module
only handles the high-level things, 
and has few control over the hardware.
On the contrary, 
QCA9300 adopts the \textit{soft}-MAC architect,
that the driver module
has the full control over almost every aspect of the hardware.
%
After thorough exploration, 
we successfully unlock the UWB spectrum access for QCA9300
by taking the full control to its $cf$ synthesizer.
Table~\ref{tab:uwb} summarizes the spectrum supported by QCA9300. 
Beside the total spectrum 2.5GHz , 
we see, in 5GHz band, 
the continually available spectrum is up to the remarkable 1.7GHz wide, 
which is $8.5x$ wider than the 5.5-5.7GHz continual spectrum available in standard channels.

\begin{table}
    \centering
    \caption{The UWB Spectrum Supported by QCA9300}
%    \vspace{-0.1in}
    \begin{tabular}{|l|c|c|} \hline
                          & 2.4GHz Band & 5GHz Band \\ \hline
      Spectrum Range(GHz) & 2.2-3.05     & 4.4-6.1  \\ \hline
      Min. Resolution(Hz) & 250         & 1000      \\ \hline
    \end{tabular}
    \label{tab:uwb}
    \vspace{-0.1in}
\end{table}


\textit{Unified Support for QCA9300 and IWL5300:}
both NICs have unique features for CSI measurement that are irreplaceable by the other.
However, they have for long time been kernel non-compatible, one with v4.1.10 and the other with v4.2.
The deprecated kernels
and the tricky installation steps have the researchers suffered a lot.
%
We solve this issue once and always.
We unify and port the CSI data collection routine of each model
into the same upstream kernel v4.15,
which is, to the date of publication, the official kernel version adopted by Ubuntu 18.04 LTS.
Besides the code migration,  
the installation gets significantly simplified.
Adopting the DKMS technology\cite{dkms}, 
we can release PicoScenes Driver in pre-built binary form, which is well-packaged in one single .deb file.
Users can \textit{install the driver by just double click}.


\textit{Enriched Measurement Data Collection:}
According to the past experience, 
the HW parameters of both Tx/Rx ends are very helpful to CSI data analysis.
However, the off-line collection and alignment are labor intensive and sometimes challenging.
%
We eliminate this complication by adopting an enriched CSI measurement log format, Rx Status (RxS), as shown in Figure~\ref{fig:rxs}.
In this data format,
\textit{Rx ExtraInfo} encapsulates the Rx-end parameters.
If the packet is injected by a PicoScenes-controlled NIC, 
Tx-end parameters will be fabricated into the packet as the \textit{Tx ExtraInfo} part.
In this way, \textit{the HW parameters of both ends are collected in a single Rx}.
% It significantly alleviates the pain of data collection and the cumbersome data alignment.

\textit{Multi-NIC Support:}
The existing CSI data collection routines\cite{halperin2011tool, xie2018precise} 
only support one Wi-Fi NIC per machine. 
It forbids the NIC array measurement or timing-sensitive measurement. 
%
We remove this limitation
by refactoring the code of RxS collection into a per-NIC mission.
The RxS data of each NIC is then exposed via the individual \textit{debugfs} nodes.
To support large-scale NIC array, 
we carefully tune the timing of kernel threads and 
avoid the potential I/O congestion.
